package intro2java.calculator;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class ButtonPanel extends JPanel implements ActionListener
{
   private JTextField _numbers;
   private Calculator _calculator;
   private boolean _inCalculation;
   private boolean _addedDecimalPoint;
   private String _operation;
   private String _firstNumber;
   private String _secondNumber;

   private static final String[] buttons = new String[] {"1", "2", "3", "+",
                                                                  "4", "5", "6", "-",
                                                                  "7", "8", "9", "*",
                                                                  "0", ".", "=", "/"};
   public ButtonPanel(JTextField numbers)
   {
      super();
      _numbers = numbers;
      LayoutManager manager = new GridLayout(4, 4);

      for (int i=0; i < buttons.length; i++)
      {
         JButton button = new JButton(buttons[i]);
         button.setActionCommand(buttons[i]);
         button.addActionListener(this);
         this.add(button);
      }

      this.setBorder(BorderFactory.createEtchedBorder());
      this.setBackground(Color.ORANGE);

      _inCalculation=false;
      _addedDecimalPoint = false;
      _calculator = new Calculator();
   }

   public void actionPerformed(ActionEvent e)
   {
      JButton button = (JButton)e.getSource();
      if (button.getActionCommand() == "1" ||
         button.getActionCommand() == "2"||
         button.getActionCommand() == "3"||
         button.getActionCommand() == "4"||
         button.getActionCommand() == "5"||
         button.getActionCommand() == "6"||
         button.getActionCommand() == "7"||
         button.getActionCommand() == "8"||
         button.getActionCommand() == "9"||
         button.getActionCommand() == "0")
      {
         _numbers.setText( _numbers.getText() + button.getActionCommand() );
         if (!_inCalculation)
         {
            _firstNumber = _numbers.getText();
         }
         else
         {
            _secondNumber = _numbers.getText();
         }
      }
      else if (button.getActionCommand() == ".")
      {
         if (!_addedDecimalPoint)
         {
            _numbers.setText( _numbers.getText() + button.getActionCommand() );
            if (!_inCalculation)
            {
               _firstNumber = _numbers.getText();
            }
            else
            {
               _secondNumber = _numbers.getText();
            }
            _addedDecimalPoint = true;
         }
      }
      else if (button.getActionCommand() == "=")
      {
         if (_inCalculation)
         {
         double answer = _calculator.calculate(_operation, Double.parseDouble(_firstNumber),
                                                Double.parseDouble(_secondNumber));

         _numbers.setText( answer + "" );
         _inCalculation = false;
         _firstNumber = _numbers.getText();
         }
      }
      else if (button.getActionCommand() == "reset")
      {
         _numbers.setText("");
         _inCalculation = false;
         _firstNumber = null;
         _secondNumber = null;
         _addedDecimalPoint = false;

      }
      else
      {
         _numbers.setText("");
         _operation = button.getActionCommand();
         _inCalculation = true;
         _addedDecimalPoint = false;
      }


   }
}

