package intro2java.swing;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;


public class ActionEventViewer extends EventViewer implements ActionListener
{

   public ActionEventViewer()
   {
      JPanel panel = new JPanel();
      panel.setSize(100,100);

      JButton one = new JButton("one");
      one.setActionCommand("ONE!");
      one.addActionListener(this);
      panel.add(one);

      JButton two = new JButton("two");
      two.setActionCommand("TWO!");
      two.addActionListener(this);
      panel.add(two);

      JButton three = new JButton("three");
      three.setActionCommand("THREE!");
      three.addActionListener(this);
      panel.add(three);

      getContentPane().add(panel, BorderLayout.NORTH);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

   }

   protected String getWindowTitle()
   {
      return "Action Event Viewer";
   }

   public static void main(String[] args)
   {
      EventViewer viewer = new ActionEventViewer();
      viewer.show();
   }

   public void actionPerformed(ActionEvent event)
   {
      StringBuffer buffer = new StringBuffer("Button Clicked!\n");
      buffer.append( "When: " + new java.util.Date( event.getWhen() ) + "\n");
      buffer.append( "Command: " + event.getActionCommand() + "\n");
      buffer.append( "\n\n" );
      _textArea.append(buffer.toString());
   }

}
