package intro2java.swing;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class MouseEventViewer extends EventViewer implements MouseListener
{

   private JPanel _panel;

   public MouseEventViewer()
   {
      _panel = new JPanel();
      _panel.setSize(100,100);
      _panel.add(new JLabel("Click this panel"));
      _panel.setBackground(Color.CYAN);
      _panel.addMouseListener(this);
      getContentPane().add(_panel, BorderLayout.NORTH);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }

   protected String getWindowTitle()
   {
      return "Mouse Event Viewer";
   }


   public static void main(String[] args)
   {
      EventViewer viewer = new MouseEventViewer();
      viewer.show();
   }

   public void mouseClicked(MouseEvent event)
   {
      printMouseEvent("Mouse Clicked!", event);
   }

   public void mouseEntered(MouseEvent event)
   {
      printMouseEvent("Mouse Entered!", event);
   }

   public void mouseExited(MouseEvent event)
   {
      printMouseEvent("Mouse Exited!", event);
   }

   public void mousePressed(MouseEvent event)
   {
      printMouseEvent("Mouse Pressed!", event);
   }

   public void mouseReleased(MouseEvent event)
   {
      printMouseEvent("Mouse Released!", event);
   }

   private void printMouseEvent(String message, MouseEvent event)
   {
      _textArea.append(message.toUpperCase() + "\n");
      StringBuffer buffer = new StringBuffer("Event details...\n");
      buffer.append( "When: " + new java.util.Date(event.getWhen()) + "\n");
      buffer.append( "Co-ordinates: " + event.getX() + ", " + event.getY() + "\n");
      buffer.append( "Clicks: " + event.getClickCount() + "\n");
      buffer.append( "Modifiers: " + event.getMouseModifiersText( event.getModifiers() ) );
      _textArea.append(buffer.toString() + "\n\n");
   }
}
