package intro2java.swing;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author ldodds
 */
public class WindowEventViewer extends EventViewer implements WindowListener
{

   private boolean triedToClose;

   public WindowEventViewer()
   {
      this.addWindowListener(this);
      triedToClose = false;
   }


   public void hide()
   {
      if (triedToClose)
      {
         super.hide();
      }
      else
      {
         triedToClose = true;
      }
   }

   protected String getWindowTitle()
   {
      return "Window Event Listener";
   }

   public static void main(String[] args)
   {
      EventViewer viewer = new WindowEventViewer();
      viewer.show();
   }


   public void windowActivated(WindowEvent event)
   {
      printWindowEvent("Window Activated", event);
   }

   public void windowClosed(WindowEvent event)
   {
      printWindowEvent("Window Closed", event);
   }

   public void windowClosing(WindowEvent event)
   {
      printWindowEvent("Window Closing", event);
   }

   public void windowDeactivated(WindowEvent event)
   {
      printWindowEvent("Window Deactivated", event);
   }

   public void windowDeiconified(WindowEvent event)
   {
      printWindowEvent("Window Deiconified", event);
   }

   public void windowIconified(WindowEvent event)
   {
      printWindowEvent("Window Iconified", event);
   }

   public void windowOpened(WindowEvent event)
   {
      printWindowEvent("Window Opened", event);
   }

   private void printWindowEvent(String message, WindowEvent event)
   {
      StringBuffer buffer = new StringBuffer(message + "\n");
      buffer.append(event.paramString());
      buffer.append("\n\n");
      _textArea.append(buffer.toString());

   }
}
